import os
import pygame
import tkinter as t

specified_directory = os.path.join(os.path.dirname(os.path.abspath( __file__ )),"music")
print (specified_directory)
pygame.mixer.init()
pygame.init()
music_player = t.Tk()
music_player.geometry("200x200")
music_player.geometry("+10+650")
music_player.overrideredirect(True)
music_player.attributes("-alpha",0.5)

controls_frame = t.Frame(music_player)
controls_frame.pack(side=t.BOTTOM, fill=t.X,)
music_list = os.listdir(specified_directory)
music_list = [os.path.splitext(music)[0] for music in music_list if os.path.splitext(music)[1] in [".mp3", ".wav", ".ogg", ".flac"]]#只显示有这些后缀的文件，你可以加别的
listbox = t.Listbox(music_player)
for music in music_list:
    listbox.insert(t.END, music)
listbox.pack(expand=t.YES, fill=t.BOTH)
listbox.config(font=("拜托 这河狸嘛", 10), fg="white",bg="#181818")
listbox.activate(0)
listbox.selection_set(0)

music_path = os.path.join(specified_directory, music_list[0] + ".flac")
if not os.path.exists(music_path):
    music_path = os.path.join(specified_directory, music_list[0] + ".mp3")
if not os.path.exists(music_path):
    music_path = os.path.join(specified_directory, music_list[0] + ".wav")
if not os.path.exists(music_path):
    music_path = os.path.join(specified_directory, music_list[0] + ".ogg")
pygame.mixer.music.load(music_path)
music = pygame.mixer.Sound(music_path)
total_length = music.get_length() * 1000

def reload_playlist():#重新加载播放列表
    global music_list
    music_list = os.listdir(specified_directory)
    music_list = [os.path.splitext(music)[0] for music in music_list if os.path.splitext(music)[1] in [".mp3", ".wav", ".ogg", ".flac"]]
    listbox.delete(0, t.END)
    for music in music_list:
        listbox.insert(t.END, music)

def pause_music():
    if pygame.mixer.music.get_busy():
        pygame.mixer.music.pause()
        pause_button.config(text="▶️")  # 更改为播放图标
    else:
        pygame.mixer.music.unpause()
        pause_button.config(text="⏸️")  # 更改为暂停图标

def play_selected_music(event):#双击播放音乐
    music_name = listbox.get(t.ACTIVE)
    music_path = os.path.join(specified_directory, music_name + ".flac")
    if not os.path.exists(music_path):
        music_path = os.path.join(specified_directory, music_name + ".mp3")
    if not os.path.exists(music_path):
        music_path = os.path.join(specified_directory, music_name + ".wav")
    if not os.path.exists(music_path):
        music_path = os.path.join(specified_directory, music_name + ".ogg")
    if not os.path.exists(music_path):
        t.messagebox.showerror("错误", "音乐文件不存在")
        reload_playlist()
        return
    pygame.mixer.music.load(music_path)
    pygame.mixer.music.play()
    pause_button.config(text="⏸️")

listbox.bind("<Double-Button-1>", play_selected_music)

def previous_music():
    current_index = listbox.curselection()[0]
    if current_index == 0:
        previous_index = len(music_list) - 1
    else:
        previous_index = current_index - 1
    listbox.selection_clear(0, t.END)
    listbox.activate(previous_index)
    listbox.selection_set(previous_index)
    music_name = listbox.get(previous_index)
    music_path = os.path.join(specified_directory, music_name + ".flac")
    if not os.path.exists(music_path):
        music_path = os.path.join(specified_directory, music_name + ".mp3")
    if not os.path.exists(music_path):
        music_path = os.path.join(specified_directory, music_name + ".wav")
    if not os.path.exists(music_path):
        music_path = os.path.join(specified_directory, music_name + ".ogg")
    if not os.path.exists(music_path):
        t.messagebox.showerror("错误", "音乐文件不存在")
        reload_playlist()
        return
    pygame.mixer.music.load(music_path)
    pygame.mixer.music.play()
    pause_button.config(text="⏸️")

def next_music():
    current_index = listbox.curselection()[0]
    if current_index == len(music_list) - 1:
        next_index = 0
    else:
        next_index = current_index + 1
    listbox.selection_clear(0, t.END)
    listbox.activate(next_index)
    listbox.selection_set(next_index)
    music_name = listbox.get(next_index)
    music_path = os.path.join(specified_directory, music_name + ".flac")
    if not os.path.exists(music_path):
        music_path = os.path.join(specified_directory, music_name + ".mp3")
    if not os.path.exists(music_path):
        music_path = os.path.join(specified_directory, music_name + ".wav")
    if not os.path.exists(music_path):
        music_path = os.path.join(specified_directory, music_name + ".ogg")
    if not os.path.exists(music_path):
        t.messagebox.showerror("错误", "音乐文件不存在")
        reload_playlist()
        return
    pygame.mixer.music.load(music_path)
    pygame.mixer.music.play()
    pause_button.config(text="⏸️")

def check_music_end():
    for event in pygame.event.get():
        if event.type == MUSIC_END:
            next_music()
    music_player.after(100, check_music_end)

MUSIC_END = pygame.USEREVENT + 1
pygame.mixer.music.set_endevent(MUSIC_END)
check_music_end()

next_button = t.Button(controls_frame, text="⏭️", bg="#181818", fg="white", font="{拜托 这河狸嘛}", command=next_music)
pause_button = t.Button(controls_frame, text="暂未播放", bg="#181818", fg="white", font="{拜托 这河狸嘛}", command=pause_music)
previous_button = t.Button(controls_frame, text="⏮️", bg="#181818", fg="white", font="{拜托 这河狸嘛}", command=previous_music)

previous_button.pack(side=t.LEFT, expand=t.YES, fill=t.BOTH)
pause_button.pack(side=t.LEFT, expand=t.YES, fill=t.BOTH)
next_button.pack(side=t.LEFT, expand=t.YES, fill=t.BOTH)

music_player.mainloop()
